"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class RequestDetails(ProtocolElement):
    """
    Details about the transaction sender
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {}

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_4 import cva as cva_1_5_0

        return {
            "org.gel.models.cva.avro.RequestDetails": cva_1_5_0.RequestDetails,
        }

    __slots__ = [
        "authType",
        "host",
        "ip",
        "port",
        "uri",
        "url",
        "user",
    ]

    def __init__(
        self,
        authType=None,
        host=None,
        ip=None,
        port=None,
        uri=None,
        url=None,
        user=None,
        validate=None,
        **kwargs
    ):
        """Initialise the cva_1_5_0.RequestDetails model.

        :param authType:
            Authentication type
        :type authType: None | str
        :param host:
            Hostname
        :type host: None | str
        :param ip:
            IP address
        :type ip: None | str
        :param port:
            Port
        :type port: None | int
        :param uri:
            URI
        :type uri: None | str
        :param url:
            URL
        :type url: None | str
        :param user:
            User
        :type user: None | str
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "1.5.0"
